﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Kendo.Mvc.UI;
using Kendo.Mvc.Extensions;
using grid_eddit_with_cascading_dd1.Models;

namespace grid_eddit_with_cascading_dd1.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            var customers = GCustsOne();
            ViewData["defaultCustomer"] = customers.OrderBy(c => c.CustomerId).First();
            var vendors = GVendsOne();
            ViewData["defaultVendor"] = vendors.OrderBy(v => v.VendorId).First();
            var products = GProdsOne();
            ViewData["defaultProduct"] = products.OrderBy(p => p.ProductId).First();

            return View();
        }

        [HttpPost]
        public JsonResult Read([DataSourceRequest] DataSourceRequest request)
        {
            var data = LicenseRepository.Repository.GetAll();

            return Json(LicenseRepository.Repository.GetAll().ToDataSourceResult(request));
        }

        [HttpPost]
        public JsonResult Create([DataSourceRequest] DataSourceRequest request, License license)
        {
            if (license != null && ModelState.IsValid)
            {
                LicenseRepository.Repository.Insert(license);
            }

            return Json(new[] { license }.ToDataSourceResult(request, ModelState));
        }

        [HttpPost]
        public JsonResult Update([DataSourceRequest] DataSourceRequest request, License license)
        {
            if (license != null && ModelState.IsValid)
            {
                LicenseRepository.Repository.Update(license);
            }

            return Json(ModelState.ToDataSourceResult());
        }

        private List<Customer> GCustsOne()
        {
            return CustomerRepository.Repository.Customers.ToList();
        }
        private List<Vendor> GVendsOne()
        {
            return VendorRepository.Repository.Vendors.ToList();
        }
        private List<Product> GProdsOne()
        {
            return ProductRepository.Repository.Products.ToList();
        }

        public JsonResult GetCustomers()
        {
            return Json(CustomerRepository.Repository.Customers, JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetVendors(int customerId)
        {
            return Json(VendorRepository.Repository.GetVendorsByCustomer(customerId), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetProducts(int vendorId)
        {
            return Json(ProductRepository.Repository.GetProductsByVendor(vendorId), JsonRequestBehavior.AllowGet);
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}