﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace grid_eddit_with_cascading_dd1.Models
{
    public class LicenseRepository
    {
        public static LicenseRepository Repository = new LicenseRepository();

        public List<License> Licenses
        {
            get
            {
                List<License> result = (List<License>)HttpContext.Current.Session["Licenses"];

                if (result == null)
                {
                    //var seedLicense = new License
                    //{
                    //    LicenseId = 1,
                    //    Customer = new Customer { CustomerId = 1, CustomerName = "Tony" },
                    //    Vendor = new Vendor { VendorId = 1, VendorName = "Apple", CustomerId = 1 },
                    //    Product = new Product { ProductId = 1, ProductName = "IPhone", VendorId = 1 }

                    //};
                    //result = new List<License>();
                    //result.Add(seedLicense);
                    //HttpContext.Current.Session["Licenses"] = result;
                    HttpContext.Current.Session["Licenses"] = result = new List<License>();
                }

                return result;
            }
        }

        public List<License> GetAll()
        {
            return Licenses;
        }

        public void Insert(License license)
        {
            var last = Licenses.LastOrDefault();

            license.LicenseId = last != null ? last.LicenseId + 1 : 1;

            Licenses.Add(license);

            HttpContext.Current.Session["Licenses"] = Licenses;
        }

        public void Update(License license)
        {
            var old = Licenses.Where(l => l.LicenseId == license.LicenseId).FirstOrDefault();

            if (old != null)
            {
                old.Customer.CustomerId = license.Customer.CustomerId;
                old.Customer.CustomerName = license.Customer.CustomerName;
                old.Vendor.VendorId = license.Vendor.VendorId;
                old.Vendor.VendorName = license.Vendor.VendorName;
                old.Vendor.CustomerId = license.Vendor.CustomerId;
                old.Product.ProductId = license.Product.ProductId;
                old.Product.ProductName = license.Product.ProductName;
                old.Product.VendorId = license.Product.VendorId;
            }

            HttpContext.Current.Session["Licenses"] = Licenses;
        }
    }
}