﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace grid_eddit_with_cascading_dd1.Models
{
    public class ProductRepository
    {
        public static ProductRepository Repository = new ProductRepository();

        public IEnumerable<Product> Products
        {
            get
            {
                IEnumerable<Product> result = (IEnumerable<Product>)HttpContext.Current.Session["Products"];

                if (result == null)
                {
                    HttpContext.Current.Session["Products"] = result = GenerateProducts();
                }

                return result;
            }
        }

        public IEnumerable<Product> GetProductsByVendor(int vendorId)
        {
            return Products.Where(p => p.VendorId == vendorId);
        }

        private IEnumerable<Product> GenerateProducts()
        {
            var list = new List<Product>();
            list.Add(new Product
            {
                ProductId = 1,
                ProductName = "IPhone",
                VendorId = 1
            });

            list.Add(new Product
            {
                ProductId = 2,
                ProductName = "IMac",
                VendorId = 1
            });

            list.Add(new Product
            {
                ProductId = 3,
                ProductName = "3-Series" ,
                VendorId = 2
            });

            list.Add(new Product
            {
                ProductId = 4,
                ProductName = "X5",
                VendorId = 2
            });

            list.Add(new Product
            {
                ProductId = 5,
                ProductName = "Jabber" ,
                VendorId = 3
            });

            list.Add(new Product
            {
                ProductId = 6,
                ProductName = "Other Cisco products",
                VendorId = 3
            });

            list.Add(new Product
            {
                ProductId = 7,
                ProductName = "D-Wave P1",
                VendorId = 4
            });

            list.Add(new Product
            {
                ProductId = 8,
                ProductName = "D-Wave P2",
                VendorId = 4
            });

            list.Add(new Product
            {
                ProductId = 9,
                ProductName = "Enron-lies",
                VendorId = 5
            });

            list.Add(new Product
            {
                ProductId = 10,
                ProductName = "Enron-more-lies",
                VendorId = 5
            });

            list.Add(new Product
            {
                ProductId = 11,
                ProductName = "Java",
                VendorId = 6
            });

            list.Add(new Product
            {
                ProductId = 12,
                ProductName = "Eclipse-IDE",
                VendorId = 6
            });

            list.Add(new Product
            {
                ProductId = 13,
                ProductName = "Windows-10",
                VendorId = 7
            });

            list.Add(new Product
            {
                ProductId = 14,
                ProductName = "Xbox",
                VendorId = 7
            });

            list.Add(new Product
            {
                ProductId = 15,
                ProductName = "Google-Pixel",
                VendorId = 8
            });

            list.Add(new Product
            {
                ProductId = 16,
                ProductName = "Android",
                VendorId = 8
            });

            list.Add(new Product
            {
                ProductId = 17,
                ProductName = "S-Class",
                VendorId = 9
            });

            list.Add(new Product
            {
                ProductId = 18,
                ProductName = "C-Class",
                VendorId = 9
            });

            list.Add(new Product
            {
                ProductId = 19,
                ProductName = "A-4",
                VendorId = 10
            });

            list.Add(new Product
            {
                ProductId = 20,
                ProductName = "A-8",
                VendorId = 10
            });

            list.Add(new Product
            {
                ProductId = 21,
                ProductName = "Cadilac",
                VendorId = 11
            });

            list.Add(new Product
            {
                ProductId = 22,
                ProductName = "Chevrolete",
                VendorId = 11
            });

            list.Add(new Product
            {
                ProductId = 23,
                ProductName = "XPS-15",
                VendorId = 12
            });

            list.Add(new Product
            {
                ProductId = 24,
                ProductName = "XPS-13",
                VendorId = 12
            });
            return list;
        }
    }
}