﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace grid_eddit_with_cascading_dd1.Models
{
    public class VendorRepository
    {
        public static VendorRepository Repository = new VendorRepository();

        public IEnumerable<Vendor> Vendors
        {
            get
            {
                IEnumerable<Vendor> result = (IEnumerable<Vendor>)HttpContext.Current.Session["Vendors"];

                if (result == null)
                {
                    HttpContext.Current.Session["Vendors"] = result = GenerateVendors();
                }

                return result;
            }
        }

        public IEnumerable<Vendor> GetVendorsByCustomer(int customerId)
        {
            return Vendors.Where(p => p.CustomerId == customerId);
        }

        private IEnumerable<Vendor> GenerateVendors()
        {
            var list = new List<Vendor>();

                list.Add(new Vendor
                {
                    VendorId = 1,
                    VendorName = "Apple",
                    CustomerId = 1
                });
                list.Add(new Vendor
                {
                    VendorId = 2,
                    VendorName = "Bmw",
                    CustomerId = 1
                });

                list.Add(new Vendor
                {
                    VendorId = 3,
                    VendorName = "Cisco",
                    CustomerId = 2
                });
                list.Add(new Vendor
                {
                    VendorId = 4,
                    VendorName = "D-Wave",
                    CustomerId = 2
                });
                list.Add(new Vendor
                {
                    VendorId = 5,
                    VendorName = "Enron",
                    CustomerId = 3
                });
                list.Add(new Vendor
                {
                    VendorId = 6,
                    VendorName = "Sun-Micro-Systems",
                    CustomerId = 3
                });
                list.Add(new Vendor
                {
                    VendorId = 7,
                    VendorName = "Microsoft",
                    CustomerId = 4
                });
                list.Add(new Vendor
                {
                    VendorId = 8,
                    VendorName = "Google",
                    CustomerId = 4
                });
                list.Add(new Vendor
                {
                    VendorId = 9,
                    VendorName = "Mercedes",
                    CustomerId = 5
                });
                list.Add(new Vendor
                {
                    VendorId = 10,
                    VendorName = "Audi",
                    CustomerId = 5
                });
                list.Add(new Vendor
                {
                    VendorId = 11,
                    VendorName = "GM",
                    CustomerId = 6
                });
                list.Add(new Vendor
                {
                    VendorId = 12,
                    VendorName = "Dell",
                    CustomerId = 6
                });
            return list;
        }

    }
}